#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

int Err_Func(char * msg)
{
	printf("\nError: %s\n", msg);
	printf("Required use: ./list_generator A n   where 'A' is matrix name, 'n' is size.\n");
	printf("Use 'A', 'B' or 'C' for matrix name, any integer (don't use commas) for 'n'.\n\n");
	return 1;
}

int main(int num, char * items[])
{
if (num == 1)
	return Err_Func("Use parameters in command line.\n");

if (num == 2)
	return Err_Func("Parameter missing in command line.\n");

if (num > 3)
	return Err_Func("Too many parameters in command line.\n");

//num = 3  Just right!
if ((items[1][0] != 'A') && (items[1][0] != 'B') && (items[1][0] != 'C'))
	return Err_Func("Mucked up name.\n");

int size;
size = atoi(items[2]);
printf("Size = %d.\n", size);
if (size == 0)
	return Err_Func("Size should be an integer less than 3 zillion.\n");

//Everything's cool - build filename.
char fileName[80];
strcpy(fileName, "");
strcat(fileName, items[1]);
strcat(fileName, items[2]);
strcat(fileName, ".bin");
printf("File = %s.\n", fileName);

//create file
int randval = 0;
int rand1 = 0;
double temp = 0.0;
int seed = time(NULL);
srand(seed);

FILE *fp;
fp = fopen(fileName, "wb");

if (!fp)
	return Err_Func("File open failed - call Karl.\n");

printf("Rand_Max = %d\n", RAND_MAX);
//write size-squared records to the file
int rec = 0;
while (rec < size)
{
	rand1 = (int)rand();
//	printf("value %d is %d\n", rec, rand1);
	fwrite(&rand1, 4, 1, fp);
	rec = rec + 1;
}

fclose(fp);

return 0;
}

